require "remme/scheduler"
require "remme/demonizer"

require "remme/player/base"
require "remme/player/adapters/spotify"

require "remme/notifier/base"
require "remme/notifier/adapters/say"

module Remme
  class Runner
    include Demonizer

    class << self
      def run(options)
        new(options).run
      end
    end

    def initialize(options)
      @options = options.merge(
        notifier: notifier,
        after_hook: ->() { player.play },
        before_hook: ->() { player.pause }
      )
    end

    def run
      demonize(Process) do
        Scheduler.run(@options)
        until Scheduler.completed? do end
      end
    end

    private

    def player
      @player ||= Player::Base.init
    end

    def notifier
      @notifier ||= Notifier::Base.init
    end
  end
end
