module Player
  class Base
    class << self
      def init
        self.tap do
          @adapter = adapter
          @was_playing = adapter.being_played?
        end
      end

      def pause
        return if !@was_playing
        @adapter.pause
      end

      def play
        return if !@was_playing
        @adapter.play
      end

      private

      def adapter
        Adapters::Spotify
      end
    end
  end
end
